<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf-8" />
        <title>Maps</title>
        <link href="Content/bootstrap.min.css" rel="stylesheet" />
        <link rel="preconnect" href="https://fonts.gstatic.com">
        <script src="https://kit.fontawesome.com/ab2155e76b.js" crossorigin="anonymous"></script>
        <link href="https://fonts.googleapis.com/css2?family=Poppins&display=swap" rel="stylesheet">
        <link href="app.css" rel="stylesheet" />
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.3/css/bulma.min.css">
        <script src="https://use.fontawesome.com/releases/v5.15.4/js/all.js" data-auto-a11y="true" ></script>
        <!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
        <script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBCUND52A1f32pSXeXyoJzt3dMIy7N_CDE&libraries=places"></script>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>
        <!-- Include all compiled plugins (below), or include individual files as needed -->
        <script src="Scripts/jquery-3.1.1.min.js"></script>
        <!-- <script src="{{url_for('static', filename='main.js')}}"></script> -->
        <style>
            html{
                background-color: #f0f0f0;
            }

            #overlay {
                position: absolute;
                left: 0;
                top: 0;
                bottom: 0;
                right: 0;
                background: #a1a1a1;
                opacity: 0.60;
                filter: alpha(opacity=80);
            }
            #loading {
                width: 100px;
                height: 100px;
                position: absolute;
                top: 50%;
                left: 50%;
                margin: -28px 0 0 -25px;
            } 
        </style>
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <script>
        
            $(document).ready(function() {

                $('#toggled').on('keyup keypress', function(e) {
                    var keyCode = e.keyCode || e.which;
                    if (keyCode === 13) { 
                        e.preventDefault();
                        return false;
                    }
                });

    $('#toggled').on('change', function() {

        var empty = false;
        var empty2 = false;
        $('.field input').each(function() {
            if ($(this).val().length == 0) {
                empty = true
            }
        });

        if ($('#select').val() == ""){
            empty2 = true;
        }

        if (empty || empty2) {
            $('.actions input').attr('disabled', 'disabled');
        } else {
            $('.actions input').attr('disabled', false);
        }
    });
            });

            $(function(){
                $('#gif').on('click', function(event)
                {
                    // event.preventDefault();
                    
                    $('body').append(
                        '<div id="overlay">' +
                        '<img id="loading" src="../static/loading.gif">' +
                        '</div>'
                    );
                    
                    
                });
            })

        </script>
        
    </head>
    <body>
        <div style="width: 69%; height: 400px; margin: auto; padding: 10px;">
            <div class="box" id="box" style="width: 30%; height: 100%; float: left;"> 
                <div class="block">
                    <form id="toggled" method="post" action="/">
                        <div style="width: 100%; height: 25%; margin: auto; padding-top: 10px; padding-bottom: 10px;">
                            <div class="field" style="width: 69%; height: 100%; float:left;">
                                <label class="has-text-weight-bold">Modele de vehicule:</label><br>
                                <div class="select" style="margin-top: 8px">
                                    <select id="select" name="car_id" required>
                                        <option value="">--Please choose a vehicule--</option>
                                        {% for key, value in cars.items() %}
                                        <option value="{{ key }}">{{ value }}</option>
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                            <div class="field" style="margin-left: 71%; height: 100%;">
                                <label class="has-text-weight-bold">Pourcentage:</label><br>
                                <div class="select" style="margin-top: 8px">
                                    <select name="pourcentage" required>
                                        <option value="100">100%</option>
                                        <option value="90">90%</option>
                                        <option value="80">80%</option>
                                        <option value="70">70%</option>
                                        <option value="60">60%</option>
                                        <option value="50">50%</option>
                                        <option value="40">40%</option>
                                        <option value="30">30%</option>
                                    </select>
                                </div>
                            </div>
                        </div>

                        <div class="field" style="margin-top: 10px;">
                            <label class="label has-text-weight-bold">Départ: </label>
                                <input type="text" class="input" id="source" placeholder="Départ" name="source" required>
                        </div>              

                        <div class="field" style="margin-top: 10px;">
                            <label class="label has-text-weight-bold">Destination: </label>
                                <input type="text" class="input" id="destination" placeholder="Destination" name="destination" required>
                        </div>
                        
                        <div class="field" style="margin-top: 10px;">
                            <div class="field-label">
                                <!-- Left empty for spacing -->
                            </div>
                            <div class="control">
                                <div class="actions">
                                    <input class="button is-link is-small is-dark" type="submit" id="gif" value="Calculer" disabled="disabled" name="action1"></input>
                                </div>
                            </div>
                        </div>    
                    </form>     
                </div>
            </div>
            <!-- margin:1%;  width:350px; float: right; right: 50%; position: relative; -->
            {% if start_location is defined %}
            <div style="margin-left: 32%; height: 100%;">
                <div class="box" id="box">
                    <div class="block" style="height:100%;">
                        <div class="content" style="height:100%;">
                            
                            <div style="width: auto; height: 32%; padding: 10px;">
                                <div style="width:49%; height: 100%; float: left; text-align: center; font-size: fit-height ; font-family: 'Bowlby One SC', cursive;"><img width="50px;" style="margin-right: 10px; vertical-align: middle;" src="../static/start.png">{{start_location}}</div>
                                <div style="margin-left: 51; height: 100%; text-align: center; font-size: fit-height ; font-family: 'Bowlby One SC', cursive;"><img width="50px;" style="margin-right: 10px; vertical-align: middle;" src="../static/end.png">{{end_location}}</div>
                            </div>
                        </div>
                    </div>
                </div>
            
                <div class="box" id="box">
                    <div class="block" style="height:100%;">
                        <div class="content" style="height:100%;">
                            <div style="width: auto; height: 68%; padding: 10px;">
                                <div style="float: left; width: 49%; height: auto;" >
                                    <div style="width: auto; height: 33%; padding-top: 10px; padding-bottom: 10px; font-size: 1.3em;"><img width="40px;" style="margin-right: 10px; vertical-align: middle;" src="../static/model.png">{{model}}</div>
                                    <div style="width: auto; height: 33%; padding-top: 10px; padding-bottom: 10px; font-size: 1.3em;"><img width="40px;" style="margin-right: 10px; vertical-align: middle;" src="../static/autonomy.png">{{autonomy}} kilomètres</div>
                                
                                    <div style="width: auto; height: 33%; padding-top: 10px; padding-bottom: 10px; font-size: 1.3em;">
                                        {% if nbr_recharge == 0 %}
                                            <img width="40px;" style="margin-right: 10px;" src="../static/recharge.png">{{recharge_time}} minutes
                                        {% else %}
                                            <img width="40px;" style="margin-right: 10px;" src="../static/recharge.png">{{recharge_time}} minutes (recharge : {{nbr_recharge}})
                                        {% endif %}
                                    </div>
                                </div>
                                <div style="margin-left: 51%; height: 100%;">
                                    <div style="width: auto; height: 49%; padding-top: 20px; font-size: 1.3em; padding-bottom: 20px;"><img width="40px;" style="margin-right: 10px; vertical-align: middle;" src="../static/distance.png">{{distance}}</div>
                                    <div style="width: auto; height: 49%; padding-bottom: 20px; font-size: 1.3em; padding-top: 20px;"><img width="40px;" style="margin-right: 10px;  vertical-align: middle;" src="../static/time.png">{{duree}}</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            {% endif %}
        </div>


        
        <div class="container-fluid">
            <center>
                <div class="box" style="height:500px; width:1300px;">
                    <div id="googleMap" style="position: relative; width: 1250px; height: 450px; margin: 0 auto;"></div>
                </div>
            </center>
            {% if start_location is defined %}
                <div>
                    <script>
                        //javascript.js
                        //set map options
                        var myLatLng = { lat: 46.292583, lng: 1.982312 };
                        var mapOptions = {
                            center: myLatLng,
                            zoom: 5,
                            mapTypeId: google.maps.MapTypeId.ROADMAP
                        };
            
                        //create map
                        var map = new google.maps.Map(document.getElementById('googleMap'), mapOptions);
            
                        //create a DirectionsService object to use the route method || get a result for our request
                        var directionsService = new google.maps.DirectionsService();
            
                        //create a DirectionsRenderer object which we will use to display the route
                        var directionsDisplay = new google.maps.DirectionsRenderer();
            
                        //bind the DirectionsRenderer to the map
                        directionsDisplay.setMap(map);

                        var marker = new google.maps.Marker({
                            position: { lat: 46.292583, lng: 1.982312 }, 
                            map: map, 
                            title:"Marker"
                        });
                        
                        //create request document.getElementById("source").value  document.getElementById("destination").value
                        
                        if ("{{ waypoints|safe }}" == "[]") {
                            var request = {
                            origin: "{{ start_location }}",
                            destination: "{{ end_location }}",
                            optimizeWaypoints: true,
                            travelMode: google.maps.TravelMode.DRIVING, 
                            unitSystem: google.maps.UnitSystem.IMPERIAL
                            }
                        } else {
                            var request = {
                            origin: "{{ start_location }}",
                            destination: "{{ end_location }}",
                            waypoints: {{ waypoints|safe }},
                            optimizeWaypoints: true,
                            travelMode: google.maps.TravelMode.DRIVING, 
                            unitSystem: google.maps.UnitSystem.IMPERIAL
                            }
                        }
                        
        
                        //pass the request to the route method
                        directionsService.route(request, function (result, status) {
                            if (status == google.maps.DirectionsStatus.OK) {
        
                                //Get distance || time
                                // const output = document.querySelector('#output');
                                // output.innerHTML = "<div class='alert-info'>From: " + document.getElementById("from").value + ".<br />To: " + document.getElementById("to").value + ".<br /> Driving distance <i class='fas fa-road'></i> : " + result.routes[0].legs[0].distance.text + ".<br />Duration <i class='fas fa-hourglass-start'></i> : " + result.routes[0].legs[0].duration.text + ".</div>";
        
                                //display route
                                directionsDisplay.setDirections(result);
                                
                            } else {
                                //delete route from map
                                directionsDisplay.setDirections({ routes: [] });
                                //center map in London
                                map.setCenter(myLatLng);
        
                                //show error message
                                output.innerHTML = "<div class='alert-danger'><i class='fas fa-exclamation-triangle'></i> Could not retrieve driving distance.</div>";
                            }
                        });
            
            
                        //create autocomplete objects for all inputs
                        var options = {
                            types: ['(cities)']
                        }
            
                        var input1 = document.getElementById("source");
                        var autocomplete1 = new google.maps.places.Autocomplete(input1, options);
            
                        var input2 = document.getElementById("destination");
                        var autocomplete2 = new google.maps.places.Autocomplete(input2, options);
            
                    </script>
                    
                </div>
            {% endif %}
        </div>



        <script>

            //javascript.js
            //set map options
            var myLatLng = { lat: 46.292583, lng: 1.982312 };
            var mapOptions = {
                center: myLatLng,
                zoom: 5,
                mapTypeId: google.maps.MapTypeId.ROADMAP
            };

            //create map
            var map = new google.maps.Map(document.getElementById('googleMap'), mapOptions);

            //create a DirectionsService object to use the route method || get a result for our request
            var directionsService = new google.maps.DirectionsService();

            //create a DirectionsRenderer object which we will use to display the route
            var directionsDisplay = new google.maps.DirectionsRenderer();

            //bind the DirectionsRenderer to the map
            directionsDisplay.setMap(map);


            //create autocomplete objects for all inputs
            var options = {
                types: ['(cities)']
            }
            
            var input1 = document.getElementById("source");
            var autocomplete1 = new google.maps.places.Autocomplete(input1, options);

            var input2 = document.getElementById("destination");
            var autocomplete2 = new google.maps.places.Autocomplete(input2, options);
        </script>
    </body>
</html>
